package ida.pelab.cgn;


import java.io.File;
import java.net.URLDecoder;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
;

public class XMLSettingReader implements ISettingReader {
	
	
	protected  DocumentBuilderFactory dbfbBuilder;
	protected File xmlFile;

	public  boolean loadXmlFile() {
		
		
		try {
		
			setDbfbBuilder(DocumentBuilderFactory.newInstance());

			String packagePath = ICodeGenerator.class.getResource(
					"ICodeGenerator.class").getPath();
			String databasePath = packagePath.substring(0, packagePath
					.lastIndexOf("/") + 1)
					+ "TargetArchitecture.xml";
			String externalPath = System.getProperty("user.dir") + "/"
					+ "TargetArchitecture.xml";
			xmlFile = new File(externalPath);
			if (!xmlFile.exists()) {
				xmlFile = new File(URLDecoder.decode(databasePath, "UTF-8"));
				if (!xmlFile.exists()) {
					System.out
							.println("Can't find TargetArchitecture.xml file ");
					return false;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return true;

	}

	public void setDbfbBuilder(DocumentBuilderFactory dbfbBuilder) {
		this.dbfbBuilder = dbfbBuilder;
	}

	public DocumentBuilderFactory getDbfbBuilder() {
		return dbfbBuilder;
	}

	@Override
	public TargetArchitecture loadSetting() {
		// TODO Auto-generated method stub
		return null;
	}
	
	
	
	public String getDefaultPlatform() {
		try {
	
			if (!loadXmlFile())
				return null;
	
			DocumentBuilder builder = dbfbBuilder.newDocumentBuilder();
			Document patternDoc = builder.parse(xmlFile);
			XPath xpath= XPathFactory.newInstance().newXPath();
			javax.xml.xpath.XPathExpression xpathExp= xpath.compile("platforms/defaultplatform[1]/@id");
			Object result= xpathExp.evaluate(patternDoc,XPathConstants.STRING);
		    
			return (String)result;
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			return "";
		}
	}
	
	


}
