package ida.pelab.cgn.ccode;




import ida.pelab.cgn.XMLSettingReader;


import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class SettingLoader extends XMLSettingReader {

	@Override
	public CcodePlatform loadSetting() {
		try {
	
			if (!loadXmlFile())
				return null;
	
			DocumentBuilder builder = dbfbBuilder.newDocumentBuilder();
			Document patternDoc = builder.parse(xmlFile);
			XPath xpath= XPathFactory.newInstance().newXPath();
			javax.xml.xpath.XPathExpression xpathExp= xpath.compile("/platforms/architecture[@target='Ccode']");
			Object result= xpathExp.evaluate(patternDoc,XPathConstants.NODESET);
			NodeList list= (NodeList)result;
			for (int i = 0; i < list.getLength(); i++) {

				Node currentElement = list.item(i);
				if (currentElement.getNodeType() == Node.ELEMENT_NODE) {
					Element architecture = (Element) currentElement;
					String showSourceString = architecture.getAttribute("showsourcecode");
					String wrpFileName = architecture.getAttribute("wrapperfile");
					boolean showCode=false;
					if(showSourceString.equals("true"))
						showCode=true;					
					CcodePlatform cPlatform=getsubStructure(architecture);
					cPlatform.setShowCode(showCode);
					cPlatform.setWrapperFileName(wrpFileName);
					return cPlatform;
					
				}
			}

			return null;
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			return null;
		}
	}

	private static CcodePlatform getsubStructure(Element architecture) {
		ArrayList<String> directiveList= new ArrayList<String>();
		
			Element directive= seekXMLtag(architecture,"directives");			
			if(directive!=null)
			{
				NodeList argList= directive.getElementsByTagName("arg");
				for(int i=0; i< argList.getLength();i++)
				{ 
					Element tmpELement= (Element) argList.item(i);
					if(tmpELement.getNodeType()==Node.ELEMENT_NODE)
					{
						String drv= tmpELement.getAttribute("name");
						directiveList.add(drv);
					}
				}
			}
	CcodePlatform platform= new CcodePlatform();
	platform.setDirectiveList(directiveList);
	return platform;
}
	private static Element seekXMLtag(Element xmlElement, String tagName) {
		NodeList structureNode = xmlElement.getElementsByTagName(tagName);
		return (Element) structureNode.item(0);

	}

	

}
