package ida.pelab.prt.constraints;

import ida.pelab.prt.generalfunctions.TraverseFunction;
import ida.pelab.prt.pattern.MatchedInstance;
import ida.pelab.prt.patternrecognitionTool.StructuralComparison;

import java.util.ArrayList;



import cetus.hir.Traversable;


public class MemoryAccess extends Constraint{
	
	public MemoryAccess(MemoryAccessType accessType, String parameter,
			String startPoint, String endPoint) {
		super();
		this.accessType = accessType;
		this.parameter = parameter;
		this.startPoint = startPoint;
		this.endPoint = endPoint;
	}
	MemoryAccessType accessType;
	String parameter ;
	String startPoint ;
	String endPoint;
	public MemoryAccessType getAccessType() {
		return accessType;
	}
	public void setAccessType(MemoryAccessType accessType) {
		this.accessType = accessType;
	}
	public String getParameter() {
		return parameter;
	}
	public void setParameter(String parameter) {
		this.parameter = parameter;
	}
	public String getStartPoint() {
		return startPoint;
	}
	public void setStartPoint(String startPoint) {
		this.startPoint = startPoint;
	}
	public String getEndPoint() {
		return endPoint;
	}
	public void setEndPoint(String endPoint) {
		this.endPoint = endPoint;
	}

	
	

	
	public boolean check(Traversable rootNode,ArrayList<MatchedInstance> nodelist )
	{
		Traversable keyNode= StructuralComparison.mapParameter(getParameter(), nodelist);
		Traversable startPoint= StructuralComparison.mapParameter(getStartPoint(), nodelist);
		Traversable endPoint= StructuralComparison.mapParameter(getEndPoint(), nodelist);
		if(keyNode==null || startPoint==null || endPoint==null)
			return false;
		
		switch (accessType) {
		case Read:
	 		 return !TraverseFunction.isRead(startPoint, endPoint,keyNode);
		case Write:
			return !TraverseFunction.isWritten(startPoint, endPoint,keyNode);
		default:
			return false;
		}
		
	}
}
