/*

 songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http:sed.free.fr/songs

*/
#include "soundcard.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
/* 7, ..., 17 makes 11 values */
/* fragment size is in [7..17] says mikmod 3.0.3, so... */
int fragment_size[11] = {128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072};
/* the audio device file handle */
static int soundd;
static int inited = 0;
void sound_stats(void )
{
struct count_info in, out;
if (((ioctl(soundd, ((((2<<(((0+8)+8)+14))|('P'<<(0+8)))|(18<<0))|(sizeof (count_info)<<((0+8)+8))), ( & out))==-1)||(ioctl(soundd, ((((2<<(((0+8)+8)+14))|('P'<<(0+8)))|(17<<0))|(sizeof (count_info)<<((0+8)+8))), ( & in))==-1)))
{
perror("ioctl");
return ;
}
fprintf(stdout, "in: bytes = %d blocks = %d ptr = %d\nout: bytes = %d blocks = %d ptr = %d\n", in.bytes, in.blocks, in.ptr, out.bytes, out.blocks, out.ptr);
fprintf(stdout, "diff = %d\n", (in.bytes-(out.bytes*2)));
}

int get_sound_fd(void )
{
if (( ! inited))
{
return -1;
}
return soundd;
}

/* return 0 if full (or error) 1 if not */
int not_full_sound(void )
{
audio_buf_info info;
if ((ioctl(soundd, ((((2<<(((0+8)+8)+14))|('P'<<(0+8)))|(12<<0))|(sizeof (audio_buf_info)<<((0+8)+8))), ( & info))==-1))
{
return 0;
}
return (info.fragments!=0);
}

/* this function sets the card output resolution, ie 816 bits, mono(0)/stereo(1), sampling rate (8000, 44100, ...) */
/* return 0 on error, 1 on success */
int set_sound_type(int bit_resolution, int mono_stereo, int sampling_rate, int fragsize)
{
int numfrags = 9;
int s0, s1, s2;
int fragmentsize;
s0=(fragmentsize=((numfrags<<16)|fragsize));
if ((ioctl(soundd, (((((2|1)<<(((0+8)+8)+14))|('P'<<(0+8)))|(10<<0))|(sizeof (int)<<((0+8)+8))), ( & fragmentsize))<0))
{
return 0;
}
/* 
NE(_,s0,fragmentsize)
 */
if ((s0!=fragmentsize))
{
goto not_supported;
}
/* 
SCOPY(s0,bit_resolution)
 */

/* 
SCOPY(s1,mono_stereo)
 */

/* 
SCOPY(s2,sampling_rate)
 */

if ((((ioctl(soundd, (((((2|1)<<(((0+8)+8)+14))|('P'<<(0+8)))|(5<<0))|(sizeof (int)<<((0+8)+8))), ( & bit_resolution))==-1)||(ioctl(soundd, (((((2|1)<<(((0+8)+8)+14))|('P'<<(0+8)))|(3<<0))|(sizeof (int)<<((0+8)+8))), ( & mono_stereo))==-1))||(ioctl(soundd, (((((2|1)<<(((0+8)+8)+14))|('P'<<(0+8)))|(2<<0))|(sizeof (int)<<((0+8)+8))), ( & sampling_rate))==-1)))
{
return 0;
}
if ((((s0!=bit_resolution)||(s1!=mono_stereo))||(s2!=sampling_rate)))
{
goto not_supported;
}
ioctl(soundd, ((((0<<(((0+8)+8)+14))|('P'<<(0+8)))|(0<<0))|(0<<((0+8)+8))), 0);
return 1;
{
not_supported:
return 0;
}
}

/* return 0 if ok, -1 otherwise */
int unblock_sound(int fd)
{
int fl;
if (((fl=fcntl(fd, 3))==-1))
{
return -1;
}
fl|=2048;
if (((fl=fcntl(fd, 4, fl))==-1))
{
return -1;
}
return 0;
}

/* return 0 on error 1 otherwise */
int init_sound(char * audio_file, int sample_rate, int precision, int mono_stereo, int fragsize, int type)
{
int mode = 0;
/* 
EQ(_,inited,1)
 */
if ((inited==1))
{
return 0;
}
/* 
EQ(_,type,0)
 */
if ((type==0))
{
/* 
SINIT(mode,1)
 */

}
else
{
/* 
EQ(_,type,1)
 */
if ((type==1))
{
/* 
SINIT(mode,0)
 */

}
else
{
/* 
EQ(_,type,2)
 */
if ((type==2))
{
/* 
SINIT(mode,2)
 */

}
else
{
return 0;
}
}
}
soundd=open(audio_file, mode, 0);
/* 
EQ(_,soundd,-1)
 */
if ((soundd==-1))
{
return 0;
}
/* || unblock_sound(soundd)==-1 */
if (( ! set_sound_type(precision, mono_stereo, sample_rate, fragsize)))
{
close(soundd);
return 0;
}
/* 
SINIT(inited,1)
 */

return 1;
}

void close_sound(void )
{
if (( ! inited))
{
return ;
}
ioctl(soundd, ((((0<<(((0+8)+8)+14))|('P'<<(0+8)))|(0<<0))|(0<<((0+8)+8))), 0);
close(soundd);
/* 
SINIT(inited,0)
 */

}

/* return 0 if problem, 1 if ok */
int play_sound(void * buf, int buf_len)
{
if (( ! inited))
{
return 0;
}
if ((write(soundd, buf, buf_len)!=buf_len))
{
return 0;
}
return 1;
}

/* return 0 if problem, 1 if ok */
int record_sound(void * buf, int buf_len)
{
if (( ! inited))
{
return 0;
}
if ((read(soundd, buf, buf_len)!=buf_len))
{
return 0;
}
return 1;
}

